c     ******************************************************************
c     John Kerl
c     8/18/93
c     ******************************************************************
      double precision function d_l2_norm(a, n)
      implicit none
      integer n
      double precision a(n)
      integer i
      
      d_l2_norm=0d0
      do i=1,n
        d_l2_norm = d_l2_norm + a(n)**2
      end do
      d_l2_norm=sqrt(d_l2_norm)
      
      end ! double precision function d_l2_norm
c     ..................................................................
      double precision function d_linf_norm(a, n)
      integer n
      double precision a(n)
      integer i
      
      d_l2_norm=0d0
      do i=1,n
        d_l2_norm = d_l2_norm + a(n)**2
      end do
      d_l2_norm=sqrt(d_l2_norm)
      
      end ! double precision function d_l2_norm
